/*
 @C:\Web_605\Sql\End_Conv\Oracle\2809_CDPTRGO_GRAVA_LIBERACAO_LOTE.sql

 Descrio:
  Trigger para insero do operador responsvel pela liberao ou cancelamento da liberao do lote + data/hora da liberao na
  tabela de log especifica CTRLLIBLOTE

 raise_application_error(-20501, '' , True);
*/

CREATE OR REPLACE TRIGGER GRAVA_LIBERACAO_LOTE
BEFORE UPDATE OF CDOPELIBLOTE,DTREALIBLOTE ON LOTE
FOR EACH ROW
DECLARE
   V_SEQUENCIAL VARCHAR2(20);
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF UPDATING THEN
      -- Se os campos estiverem preenchidos  porque ocorreu a liberao do lote, caso contrrio, ocorreu o cancelamento da lib. do lote
      IF (:NEW.CDOPELIBLOTE IS NOT NULL) AND (:NEW.DTREALIBLOTE IS NOT NULL) THEN

         NOVO_CODIGO_SC('CTRLLIBLOTE',V_SEQUENCIAL);
         V_SEQUENCIAL := TO_NUMBER(SUBSTR(V_SEQUENCIAL,11,10));

         INSERT INTO CTRLLIBLOTE
         (NRSEQLIBLOTE, CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO,
         IDOPERACAO, CDOPERADOR, DATAOPERACAO, CDJUSTIFICATIVA)
         VALUES
         (V_SEQUENCIAL, :NEW.CDFILIAL, :NEW.NRLOTEESTQ, :NEW.NRSUBLOTE, :NEW.CDPRODUTO,
          '1', V_DSREMOTEOPER, SYSDATE, :NEW.CDJUSTIFICATIVA);
      ELSE
         IF (:NEW.CDOPELIBLOTE IS NULL) AND (:NEW.DTREALIBLOTE IS NULL) AND
            (:OLD.CDOPELIBLOTE IS NOT NULL) THEN

            NOVO_CODIGO_SC('CTRLLIBLOTE',V_SEQUENCIAL);
            V_SEQUENCIAL := TO_NUMBER(SUBSTR(V_SEQUENCIAL,11,10));

            INSERT INTO CTRLLIBLOTE
            (NRSEQLIBLOTE, CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO,
            IDOPERACAO, CDOPERADOR, DATAOPERACAO, CDJUSTIFICATIVA)
            VALUES
            (V_SEQUENCIAL, :NEW.CDFILIAL, :NEW.NRLOTEESTQ, :NEW.NRSUBLOTE, :NEW.CDPRODUTO,
             '2', V_DSREMOTEOPER, SYSDATE, :NEW.CDJUSTIFICATIVA);
         END IF;
      END IF;
   END IF;
END;

/
-- VERSAO --
begin ATUVEROBJ('GRAVA_LIBERACAO_LOTE','6.05.xxx'); end;
/
